package com.bless.struts2.validate;

import java.util.Date;

import com.opensymphony.xwork2.validator.validators.AbstractRangeValidator;
/**
 * --------------------------------------------------------------------------------   
 * @Title: CheckDate.java
 * @Package validate.validator
 * @Description: 日期校验类,可以用于判断输入日期是否在min和max规定的日期范围内,该类重写
 * 				struts2的Date校验规则,增加不配置max值的情况下默认最大日期为当前日期.
 * @author JingWentao
 * @date 2011-3-25 上午09:29:07
 * @version V1.0   
 * --------------------------------------------------------------------------------
 */
public class CheckDate extends AbstractRangeValidator {

	private Date max;
    private Date min;
	
    public CheckDate() {
    	max = new Date(System.currentTimeMillis());
	}
    
	public Date getMax() {
		return max;
	}

	public void setMax(Date max) {
		this.max = max;
	}

	public Date getMin() {
		return min;
	}

	public void setMin(Date min) {
		this.min = min;
	}

	@Override
	protected Comparable<Date> getMaxComparatorValue() {
		return max;
	}

	@Override
	protected Comparable<Date> getMinComparatorValue() {
		return min;
	}
	
}
